<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-GB">
  <head>
    <title>SO2 Readme</title>
    <link rel="stylesheet" type="text/css" href="../css/fm.css"/>
  </head>
  
  <body>
    <h1><span>Special Ops 2 Documentation</span></h1>
    <ul id="navbar" class="nl">
      <li><a href="http://specialops.ath.cx/">Special Ops</a></li>
      <li><a href="http://specialops.ath.cx/boards/">SO Boards</a></li>
      <li><a href=".">Documentation Index</a></li>
    </ul>
    
    <div class="content c0">
      <h2>Intro</h2>
      <p>SO2 is yet another message board inspired by the GameFAQs boards, a "spinoff board".</p>
      <p>The vast majority of spinoff boards are derived from GameFAQs Hell, the first open source attempt at cloning GameFAQs.
         SO1 was one of these. The problem with basing anything on GFH is that the Hell in the title refers to the code more
         than anything else. This is probably the best example on the net of how <em>not</em> to write code. Just about every
         major message board to use it has fallen: SO1, whiteFyre, Outboards, Twisted Legacy. The only sensible choice is
         therefore to abandon GFH entirely. SO2 is designed to be its replacement.</p>
    </div>

    <div class="content c1">
      <h2>Installation</h2>
      <h3>System Requirements</h3>
      <ul>
        <li>PHP 5.1 with PDO-MySQL, PECL-Memcache, SPL</li>
        <li>MySQL 5</li>
        <li>memcached</li>
        <li>Any OS with a POSIX-compliant filesystem</li>
      </ul>
      <p>The Memcache parts are optional, but without them SO2 will be unable to cope with loads in excess of 100 online users
         and guarantee sub-1 second page loads.</p>
      <p>One more thing: running a spinoff board isn't the same as running a proboards site. The barriers to entry are there
         to protect you and others from yourself. Don't attempt to circumvent them.</p>
      
      <h3>Setup</h3>
      <p>The DB SQL structure is in res/. Setup is almost the same as GFH except for some things:</p>
      <ol>
        <li>No board editor. Use phpMyAdmin for now.</li>
        <li>The admin userlevel is more or less useless. See above.</li>
        <li>The DB password is set in <var class="file">res/config.ini</var>. Make sure this file is unreadable over HTTP.</li>
        <li>You need to create <var class="file">css/default.css</var> manually, either by symlink or by making a new file.</li>
        <li>If you want to make your account admin anyway or give it invites to start the board with, add stuff to the
            <var class="sql">things</var> table. Invites need an arbitrary value in the <var class="sql">data</var> column for
            authentication; read the source code of <var class="file">register.php</var>.</li>
      </ol>
    </div>

    <div class="content c0">
      <h2>More Help</h2>
      <p>If you can't figure out how to get something working, ask on the SO2 help board. You could also try the WD+P board on
         GameFAQs, but you're much less likely to get a useful answer from them.</p>
    </div>

    <div class="content c1">
      <h2>Developers<!-- Developers Developers Developers Developers--></h2>
      <h3>todo list (important first)</h3>
      <ul>
        <li>SO3</li>
        <li>Rewrite the HTML parser classes</li>
        <li>Admin tools</li>
      </ul>
      
      <h3>Source</h3>
      <p>Releases are at http://specialops.ath.cx/</p>
      <p>Old SVN is available at /repos/so2/ though it's not been updated in over a year. Don't bother.</p>
      <p>The code is formatted for space indents, width 4. 2 spaces in some places.</p>

      <h3>Technical Details</h3>
      <p>The first thing you'll notice if you look through the code is that everything is object-oriented. There are four main
         classes in use everywhere:</p>

      <h4>The Page class</h4>
      <p>This contains functions for headers, themes, footers, caching, and some error handling/access control.</p>
      <h4>The User class</h4>
      <p>This represents a user. There are three types: Anonymous, for users who aren't logged in, Registered, which represents
         a user in the database (mostly for looking at whois pages), and Authenticated, which is what you get if you log in.
         They use PHP's magic methods to hide implementation details, and do tricks like caching SQL results or bypassing them
         entirely.</p>
      <h4>The SO2_PDO class</h4>
      <p>This is the main database class. It does a bunch of magic behind the scenes to make the SQL code smaller, faster, and
         immune to SQL injection. Yes, all at once. SO2 is the first spinoff to use prepared statements throughout.</p>
      <h4>The SO2 class</h4>
      <p>This ties the three above classes together in a namespace sort of thing.</p>
      
      <hr/>
      <p>Outside the core most of the other stuff is also OOP:</p>

      <h4>Memcache</h4>
      <p>The code uses memcache to store logged in user objects and do fast username lookups. This will still work without
         memcache but it'll be much slower.</p>

      <h4>Plugin modules</h4>
      <p>Most of the classes in lib/ are actually loadable modules. If you want to make your own, just stick to the filename
         conventions and the same interfaces and it'll Just Work™, right down to appearing in the user options automatically.
         Some of the message HTML modules haven't been written yet. Nobody's working on these, go ahead and take one.</p>
    </div>

    <div class="content c0">
      <h2>Contributors</h2>
      <ul>
        <li>Old GameFAQs theme by Aquatakat</li>
        <li>Various ideas from the IRC/board regulars</li>
        <li>Want your name here? Code something.</li>
      </ul>
    </div>

    <div id="footer">
      <address>© 2004-2007 Ant P.
               | <a href="xmpp:ant@specialops.ath.cx">Jabber</a>
               | <a href="irc://specialops.ath.cx">IRC</a></address>
      <p>License: <a href="COPYING" rel="licence">BSD</a>.</p>
      <p><a href=".">Click to go back to the board list.</a></p>
    </div>
  </body>
</html>
